(define-module (ui controlpp lists ajax)
  :use-module (alterator ajax)
  :use-module (alterator woo)
  :export (init))

(define (selected-list)
  (form-value "lists"))

(define (ui-list)
  (form-update-enum "lists"
    (woo-list "/controlpp/lists" 'language (form-value "language"))))

(define (on-apply-click)
  (catch/message (lambda ()
    (woo "apply" "/controlpp" 'id (selected-list)
      'language (form-value "language"))
    (ui-list))))

(define (on-reset-click)
  (catch/message (lambda ()
    (woo "reset" "/controlpp" 'id (selected-list)
      'language (form-value "language"))
    (ui-list))))

(define (on-add-click)
  (form-replace "/controlpp/edit"))

(define (on-delete-click)
  (catch/message (lambda ()
    (woo "remove" "/controlpp" 'id (selected-list)
      'language (form-value "language"))
    (ui-list))))

(define (on-edit-click)
  (form-replace "/controlpp/edit"
    '_id (selected-list)))

(define (is-active)
  (woo-get-option (woo-read-first "/controlpp/status") 'is_active))

(define (init-form)
  (form-bind "add" "click" on-add-click)
  (form-bind "delete" "click" on-delete-click)
  (form-bind "edit" "click" on-edit-click)
  (form-bind "apply" "click" on-apply-click)
  (form-bind "reset" "click" on-reset-click)
  (ui-list))

(define (init)
  (if (is-active)
    (init-form)
    (form-replace "/controlpp/setup")))
